/*****************************************************************************\
* Copyright (c) 2003 Pelle Johansson.                                         *
* All rights reserved.                                                        *
*                                                                             *
* This file is part of the moftpd package. Use and distribution of            *
* this software is governed by the terms in the file LICENCE, which           *
* should have come with this package.                                         *
\*****************************************************************************/

/* $moftpd: table.h 1236 2004-11-24 12:49:43Z morth $ */

#ifndef _TABLE_H
#define _TABLE_H

typedef struct sized_table
{
  int size;
  const struct table *table;
} sized_table_t;

typedef struct table
{
  int tag;
  struct sized_table data;
} table_t;

typedef struct reverse_search
{
  int depth;
  const sized_table_t *table;
} reverse_search_t;

const int *search_forward (const int forwardTable[][6], int size, int tag);
const sized_table_t *search_table (const sized_table_t *table, int tag);
int search_reverse (const sized_table_t *reverseTable,
      reverse_search_t *reverseIndexes, int numIndexes, int tag, int *depth);

#endif /*_TABLE_H*/
